   CLS
   PRINT " WRLOPT v1.7"
   PRINT " ==========="
   PRINT " Programme to read named WRL file and write nodes and faces to OPT file"
   PRINT
   REM Difference to DXFOPT? Textures are RANDOM!
   REM
   PRINT "another humble offering by Lt Hag"
   PRINT "Please feel free to use this code and information to create new "
   PRINT "FREEWARE programs - and PLEASE send utilities and SOURCE CODE"
   PRINT "to the OPT project!"

   DIM STR AS STRING * 4000
   DIM COORD(1000) AS SINGLE
   DIM XYZ(333, 4) AS SINGLE
   DIM NODES(800, 3), TRIS(400, 4): REM OPT nodes & faces - NB node #0 stored in row 0, etc
   DIM WNODES(800, 4), WTRIS(400, 4): REM WRL file nodes & faces - NB node #0 stored in row 0, etc
   DIM WRLMAP(800): REM Records OPT node no. allocated to WRL node
   DIM OPTMAP(800): REM Records WRL node allocated to OPT node (got it?!!)
   DIM MIN(3), MAX(3), PNTS(3, 3)
   DIM AR AS STRING * 64
   DIM S64 AS STRING * 64
   DIM S24 AS STRING * 24
   DIM S1 AS STRING * 1
   DIM ST AS STRING * 7
   DIM SN AS STRING * 4
   DIM S4 AS STRING * 4
   DIM S2 AS STRING * 2
   DIM FACES AS STRING * 64
   DIM FACENODES(16) AS LONG
   DIM MYST AS LONG
   DIM IPOS(20)
   MAXNODES = 800: MAXTRIS = 400
   LASTCOL = 80: LASTROW = 30
   XPIXELS = 640: YPIXELS = 480: SMODE = 11
   PI = 3.1415927#
   NNODES = 0
   NTRIS = 0

   REM ON ERROR GOTO 70
   FILES "*.WRL": PRINT
70 REM continue
   INPUT "GIVE WRL FILE (INCL. EXT'N): ", a$
   INPUT "GIVE SCALE FACTOR TO APPLY : ", NODESCALE
80 OPEN a$ FOR INPUT AS #2
   FILES "*.OPT": PRINT
   INPUT "Give OPT file:", PFILE$
   PRINT PFILE$
   OPEN PFILE$ FOR BINARY AS #9
   GET #9, 5, S4: REM Read recorded file length
   LSF = CVL(MID$(S4, 1, 4)) + 8
   PRINT "OPT length="; LSF

    REM Get WRL info
    PRINT : PRINT "Reading WRL file..."
    GOSUB 3000
    INPUT "Pause..."; a$
    
    REM Scan OPT, find faces, reinsert nodes & face data

    REM Find next Node set, get no. of nodes in set NNSET , start, finish offsets
    PRINT
    PRINT "SCANNING OPT FILE..."
    SFPOS = 1
    NTRIS = 0
    MODEDGE = -1: REM Cum. variable - edges in model
    NONODES = 0: REM No. of OPT nodes
    WFACE = 0: REM WRL face currently being stored in OPT
1520 REM Get next 4 bytes, starting at SFPOS
     GET #9, SFPOS, S4
     IF S4 = "Tex0" THEN GOTO 1530: REM found texture header
     REM in that case,check for node header - longs 0,3,0,0
     MYST = CVL(MID$(S4, 1, 4))
     IF MYST = 0 THEN
	GET #9, SFPOS + 4, S4
	MYST = CVL(MID$(S4, 1, 4))
	IF MYST = 3 THEN
	   GET #9, SFPOS + 8, S4
	   MYST = CVL(MID$(S4, 1, 4))
	   IF MYST = 0 THEN
	     GET #9, SFPOS + 12, S4
	     MYST = CVL(MID$(S4, 1, 4))
	     IF MYST = 0 THEN
		REM Found nodes!!
		IF NNODES > 0 THEN GOSUB 2600: REM write previous nodes back to OPT
		SFPOS = SFPOS + 16
		PRINT "Reading OPT nodes..."
		GOSUB 2100: REM set start/finish for nodes read
		GOSUB 1100: REM read nodes triplets
		REM GOSUB 1200: REM print to screen/file
		REM GOSUB 1900: REM transform nodes for screen display
		REM INPUT "Pause..."; PAUSE$
	     END IF
	   END IF
	END IF
     END IF


     SFPOS = SFPOS + 1
     IF SFPOS > LSF GOTO 1599
      GOTO 1520

1530 REM found a texture header!
    GET #9, SFPOS + 6, S2
    CLS
    PRINT "Texture "; S2; "..."
       REM*************************************
       REM work out what follows now!
       REM Check first jump, the first 4 bytes after the null.
       FPOS = SFPOS + 9
       GET #9, FPOS, SN
       MYST = CVL(MID$(SN, 1, 4))
       a$ = HEX$(MYST)
       IF MYST = 0 THEN
	 REM OK, if next long = 1, face info follows, else skip to next texture
	 GET #9, FPOS + 4, SN
	 MYST = CVL(MID$(SN, 1, 4))
	 IF MYST = 1 THEN
	    REM found faces already, go to process them
	    GOTO 1550
	   ELSE
		REM skip out, look for next texture flag
		GOTO 1590
	 END IF
	END IF
	REM
	REM ok, must be a texture here. read size of it and skip it
	GET #9, SFPOS + 21, SN
	TEXSIZE = CVL(MID$(SN, 1, 4))
	PRINT "Texture found, size of Texture = "; TEXSIZE
	FPOS = SFPOS + 21 + 12 + TEXSIZE
	REM
	REM check new jump. If zero, face info follows
	GET #9, FPOS, SN
	MYST = CVL(MID$(SN, 1, 4))
	a$ = HEX$(MYST)
	IF MYST = 0 THEN GOTO 1550
	REM
	REM Still here? could be a new palette. skip if so and check again
	IF a$ = "CDCDCDCD" THEN
	    REM SKIP CD FILL AND PALETTE
	    FPOS = FPOS + 4096 + 8192
	    GET #9, FPOS, SN
	    MYST = CVL(MID$(SN, 1, 4))
	    a$ = HEX$(MYST)
	END IF
	REM
	REM check jump for 0 - if nothing this time, no faces.
	IF MYST = 0 THEN GOTO 1550
	    REM NO FACES! JUMP TO NEXT TEXTURE
	    PRINT "No faces this texture!"
	    PRINT "JUMP POINTER READ FROM OFFSET "; FPOS - 1
	    a$ = HEX$(MYST)
	    PRINT "JUMP POINTER :"; a$
	    SFPOS = FPOS - 1
	    GOTO 1590
	REM
	REM =========================================================
	REM
1550    FACEPOS = FPOS + 16
	REM
	REM OK, whether after texture or not, ready to read no. of
	REM faces from offset FACEPOS
	REM
	CLS
	PRINT "Texture "; S2; "..."
	PRINT "# OF FACES OFFSET = "; FACEPOS - 1
	GET #9, FACEPOS, SN
	NFACES = CVL(MID$(SN, 1, 4))
	PRINT "No. of FACES = "; NFACES
	REM
	REM face nodes...
	REM
	REM For each face:
	REM - identify WRL face to be substituted for this face
	REM   (if no WRL faces left, jump to write nodes and resume)
	REM - add new nodes to node list if not already there -
	REM   (if no room, jump to write nodes, and resume scan for next node set)
	REM - write face nodes for this WRL face to OPT
	REM when all OPT faces substituted
	REM write node co-ords to OPT
	REM resume scan for next node set
	REM
	TEXEDGE = -1: REM Edge no. counter for this texture
	REM PRINT "Current face nodes:"
	FOR IN = 1 TO NFACES
	   REM Read current face node data for this face
	   REM Allocate a WRL face to this slot if nodes available
	   FL = FACEPOS + 12 + (IN - 1) * 64: REM offset of start of face nodes
	   GET #9, FL, FACES
	   FOR IND = 1 TO 16
	     FACENODES(IND) = CVL(MID$(FACES, 1 + (IND - 1) * 4, 4))
	     REM PRINT FACENODES(IND);
	   NEXT IND
	   PRINT
	   NTRIS = NTRIS + 1: REM Total no. of faces read from OPT
	   REM
	   REM If run out of WRL faces (i.e. all done), zero remaining nodes and faces
	   IF WFACE >= NWTRIS THEN GOTO 1560
	   REM
	   REM If run out of OPT nodes, zero rest of faces and scan for next node set.
	   IF OPTNODES > NNODES - 4 THEN GOTO 1560
	   WFACE = WFACE + 1
	   PRINT "%%%%STORING WRL FACE #"; WFACE
	   REM allocate and record OR determine OPT node no.s for WRL face nodes
	   FOR WFN = 1 TO 4
	      PRINT "For Vertex "; WFN; "WTRIS node="; WTRIS(WFACE, WFN)
	      IF WTRIS(WFACE, WFN) < 0 THEN
		 REM must be 3-node face
		 FACENODES(WFN) = WTRIS(WFACE, WFN)
		 GOTO 1555: REM skip node storage
	      END IF
	      REM
	      REM Determine if this WRL node has already been allocated an OPT
	      REM node slot - if so, determine slot, if not, allocate it a slot.
	      REM WRLMAP stores opt node numbers allocated so far to WRL nodes
	      REM OPTMAP stores WRL nodes allocated to OPT nodes
	      IF WRLMAP(WTRIS(WFACE, WFN)) < 0 THEN
		 REM No OPT node allocated yet
		 OPTNODES = OPTNODES + 1
		 IF OPTNODES > NNODES THEN
		     REM No node slots left! scrap writing this WRL face
		     REM and set all subsequent OPT face nodes to 0,0,0,0
		     REM then write these nodes and proceed
		     WFACE = WFACE - 1
		     GOTO 1560
		  END IF
		  PRINT "Allocating new OPT slot:"; OPTNODES - 1; " to this WRL node:"; WTRIS(WFACE, WFN)
		  WRLMAP(WTRIS(WFACE, WFN)) = OPTNODES - 1: REM because the first OPT node# is 0
		  FACENODES(WFN) = OPTNODES - 1
		  OPTMAP(OPTNODES - 1) = WTRIS(WFACE, WFN)
		  PRINT "Co-ords for this slot:"; WNODES(WTRIS(WFACE, WFN), 1); WNODES(WTRIS(WFACE, WFN), 2); WNODES(WTRIS(WFACE, WFN), 3)
		ELSE
		  PRINT "Already got an OPT node allocated for this WRL node"
		  REM or this is a 3-node face - skip mapping
		  PRINT "Setting face vertex to OPT slot #"; WRLMAP(WTRIS(WFACE, WFN))
		  FACENODES(WFN) = WRLMAP(WTRIS(WFACE, WFN))
	      END IF
1555       NEXT WFN
	   GOTO 1565
1560       REM This bit used if face not required - set all vertices to 0
	   FOR IFI = 1 TO 4: FACENODES(IFI) = 0: NEXT IFI

1565       REM duplicate face node #s in pos'ns 13-16
	   REM also set tex and model edge counters (? :=))
	   FACENODES(8) = -1: FACENODES(12) = -1: REM Set default edge counters
	   FOR IFN = 1 TO 4
	      FACENODES(IFN + 12) = FACENODES(IFN)
	      IF FACENODES(IFN) >= 0 THEN
		 TEXEDGE = TEXEDGE + 1
		 FACENODES(IFN + 4) = TEXEDGE
		 MODEDGE = MODEDGE + 1
		 FACENODES(IFN + 8) = MODEDGE
	      END IF
	   NEXT IFN
	   CI = 0
	   PRINT "Putting face data:"
	   FOR I = 1 TO 61 STEP 4
	      CI = CI + 1
	      PRINT FACENODES(CI);
	      MID$(FACES, I, 4) = MKL$(FACENODES(CI))
	   NEXT I
	   PRINT
	   REM
	   PUT #9, FL, FACES
	   REM INPUT "PAUSE..."; a$
	NEXT IN
	REM
	REM write # of unique edges based on tex edge count
	REM
	MID$(S4, 1, 4) = MKL$(TEXEDGE + 1)
	PUT #9, FACEPOS + 8, S4
1570    REM
	

	REM
1590    REM Resume scan for next texture/nodeset!
	PRINT
       
     SFPOS = SFPOS + 1
     GOTO 1520
1599 PRINT : PRINT "==================================================="
     IF NNODES > 0 THEN GOSUB 2600: REM write last node set back to OPT
     PRINT "INPUT REPORT:"
     PRINT "No. of nodes found in OPT :"; NONODES
     PRINT "No of OPT faces found     :"; NTRIS
     PRINT "No. of WRL faces found    :"; NWTRIS
     PRINT : PRINT "SUCCESS REPORT:"
     PRINT "No. of WRL faces written  :"; WFACE
     PRINT : PRINT "==================================================="


     
     
     
     END



1100 REM Read triplets between START and FINISH
   LENGTH = FINISH - START + 1
   REM PRINT "Start = "; START
   REM PRINT "Finish= "; FINISH
   REM PRINT "Length in BYTES:"; LENGTH
   REM PRINT "Length in FLOAT:"; LENGTH / 4
   REM INPUT "Pause...:"; A$
   REM
   GET #9, START, STR: REM Read data
   REM
   REM Clear node map arrays
   FOR I = 0 TO MAXNODES
      WRLMAP(I) = -2: OPTMAP(I) = -2
      FOR J = 1 TO 3
	 NODES(I, J) = 0
      NEXT J
   NEXT I
   OPTNODES = 0: REM No. of OPT node slots allocated to WRL nodes
   RETURN


2100 REM Set start and finish to read nodes
    GET #9, SFPOS, S4: REM Read no. of nodes
    NNSET = CVL(MID$(S4, 1, 4))
    NNODES = NNSET
    PRINT "==========================================="
    PRINT "NEW NODESET DETECTED!"
    PRINT "No. of nodes this node set = "; NNSET
    NONODES = NNSET + NONODES
    PRINT "TOTAL No. of OPT nodes so far = "; NONODES
    REM INPUT "Pause..."; a$
    START = SFPOS + 8
    FINISH = START + NNSET * 3 * 4 - 1
    RETURN

2600 REM  WRITE NODES BACK TO OPT
    REM
    REM PUT appropriate nodes for this set into XYZ
    REM Put triplets back into single line
    REM Skip nodes not set = not called up in a face
	REM Write (updated?) nodes back to OPT
	REM First load co-ords into NODES from WRL coords
	FOR I = 0 TO NNSET - 1
	  IF OPTMAP(I) >= 0 THEN
	    FOR J = 1 TO 3
		NODES(I, J) = WNODES(OPTMAP(I), J) * NODESCALE
	    NEXT J
	  END IF
	NEXT I

    FOR J = 1 TO NNSET
       COORD((J - 1) * 3 + 1) = NODES(J - 1, 1)
       COORD((J - 1) * 3 + 2) = NODES(J - 1, 2)
       COORD((J - 1) * 3 + 3) = NODES(J - 1, 3)
2610 NEXT J
    REM reconvert to string and put back to file
    CI = 0
    FOR I = 1 TO LENGTH STEP 4
       PUTPOS = START - 1 + I
       CI = CI + 1
       MID$(S4, 1, 4) = MKS$(COORD(CI))
       PUT #9, PUTPOS, S4
       REM PRINT "COORD "; CI; " IS "; COORD(CI)
    NEXT I
    REM PUT #9, START, STR CAN'T DO THIS! STR too long, puts old face data back!!
    RETURN
   

     REM
3000 REM SCAN WRL FILE, LOAD NODES, FACES
     REM
     NWNODES = -1: NWTRIS = 0
     REM
     REM INPUT DATA FROM WRL FILE
     REM
3260 INPUT #2, AR
     REM PRINT AR
     IF INSTR(1, AR, "Coordinate3") THEN GOSUB 3280
     IF INSTR(1, AR, "coordIndex") THEN GOSUB 3530
     PRINT "No. of WRL nodes found:"; NWNODES + 1
     PRINT "No. of WRL faces found:"; NWTRIS
     REM INPUT "PAUSE....", P$
     IF EOF(2) THEN 3310
     GOTO 3260
3310 REM CONTINUE
     RETURN
    

     REM
3280 REM NODES INPUT
     REM
     PRINT "NODES INPUT"
     INPUT #2, AR: REM READ EXTRA LINE FOR NODE SETS
3290 LINE INPUT #2, AR
     IF INSTR(1, AR, "#Face") THEN GOTO 3290
     IF INSTR(1, AR, "]") THEN INPUT "PAUSE....", P$: RETURN
     NWNODES = NWNODES + 1
     IMARK = 1: IP = 1: IPOS(IMARK) = IP
3295  IP = IP + 1: IF IP > 64 THEN GOTO 3298
	IF MID$(AR, IP, 1) = " " OR MID$(AR, IP, 1) = "," THEN
	   WHILE MID$(AR, IP, 1) = " " OR MID$(AR, IP, 1) = ","
	     IP = IP + 1
	   WEND
	   IMARK = IMARK + 1: IPOS(IMARK) = IP
	END IF
	GOTO 3295
3298 REM
     WNODES(NWNODES, 1) = VAL(MID$(AR, IPOS(1), IPOS(2) - IPOS(1)))
     WNODES(NWNODES, 2) = VAL(MID$(AR, IPOS(2), IPOS(3) - IPOS(2)))
     WNODES(NWNODES, 3) = VAL(MID$(AR, IPOS(3), 8))
     REM INPUT #2, WNODES(NWNODES, 2)
     REM INPUT #2, WNODES(NWNODES, 3)
     REM INPUT #2, tmp
     PRINT NWNODES; WNODES(NWNODES, 1); WNODES(NWNODES, 2); WNODES(NWNODES, 3)
3370 GOTO 3290

     REM
     REM TRIANGLES INPUT
     REM
3530 PRINT "TRIANGLES INPUT"
3540 INPUT #2, AR
     IF INSTR(1, AR, "#Face") THEN GOTO 3540
     IF INSTR(1, AR, "]") THEN PRINT "END OF TRIS!": RETURN
     NWTRIS = NWTRIS + 1
     WTRIS(NWTRIS, 1) = VAL(AR)
     INPUT #2, WTRIS(NWTRIS, 2), WTRIS(NWTRIS, 3), WTRIS(NWTRIS, 4), TMP
     PRINT NWTRIS; WTRIS(NWTRIS, 1); WTRIS(NWTRIS, 2); WTRIS(NWTRIS, 3); WTRIS(NWTRIS, 4)
     REM INPUT "pause..."; AB$
3610 GOTO 3540



